#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAX 10
/**
 * Leida listist kige viksem element
 * Tsta see element listis esimeseks
 * 6p
 * */
typedef struct LIST{
	int dat;
	struct LIST *pNext;
	struct LIST *pPrev;
}LIST;
	
void sisestus(LIST*, int);
void v2ljastus(LIST*);
LIST *v2ikseim(LIST*);
LIST *t66tlus(LIST*, LIST*);
LIST *previous(LIST*, LIST*);

int main(void){
	srand(time(NULL));
	LIST *list = (LIST*)malloc(sizeof(LIST));
	sisestus(list, 0);
	printf("\n");
	v2ljastus(list);
	printf("\n");
	LIST *min = v2ikseim(list);
	list = t66tlus(list, min);
	v2ljastus(list);
	printf("\n");
	return 0;
}

void sisestus(LIST *list, int current){
	list->pNext = NULL;
	if (current >= MAX)
		return;
	list->pNext = (LIST*)malloc(sizeof(LIST));
	list->dat = rand() % 100;
	printf("%d ", list->dat);
	sisestus(list->pNext, current+1);
}

void v2ljastus(LIST *list){
	LIST *temp = list;
	while(temp->pNext != NULL){
		printf("%d ", temp->dat);
		temp = temp->pNext;
	}
}

LIST *v2ikseim(LIST *list){
	LIST *temp = list, *pMin;
	int min = temp->dat;
	pMin = temp;
	temp = temp->pNext;
	while(temp->pNext != NULL){
		if(min > temp->dat){
			min = temp->dat;
			pMin = temp;
		}
		temp = temp->pNext;
	}
	return pMin;
}

LIST *t66tlus(LIST *list, LIST *min){
	LIST *prev = previous(list, min);
	if(prev == NULL)
		return list;
	prev->pNext = min->pNext;
	min->pNext = list;
	return min;
}

LIST *previous(LIST *list, LIST *min){
	LIST *temp = list;
	LIST *prev = NULL;
	while(temp != min){
		prev = temp;
		temp = temp->pNext;
	}
	if(prev == NULL)
		return NULL;
	return prev;
}
